#include <iostream>

//// Part 1
template <char x, char y> const char Combine = '?';
template <> const char Combine<'R', 'R'> = 'R';
template <> const char Combine<'G', 'G'> = 'G';
template <> const char Combine<'B', 'B'> = 'B';
template <> const char Combine<'R', 'G'> = 'B';
template <> const char Combine<'R', 'B'> = 'G';
template <> const char Combine<'G', 'R'> = 'B';
template <> const char Combine<'G', 'B'> = 'R';
template <> const char Combine<'B', 'R'> = 'G';
template <> const char Combine<'B', 'G'> = 'R';

//// Part 2

template <char ...clist> struct Row;

template <char x, char ...clist> struct RemoveFirst {
  using Result = Row<clist...>;
};

template<char ...xlist> struct Zip {
  template<char ...ylist> struct With {
    using Result = typename RemoveFirst<Combine<xlist, ylist>...>::Result;
  };
};

//template <char ...clist> struct Row {};

//// Part 3

template <char ...clist> struct Row {
  using Next = typename Zip<'?', clist...>::template With<clist..., '?'>::Result;
};

template <char f, char ...clist> struct Row<f, '?', clist...>
{
  static const char Result = f;
};

//// Part 4
// https://en.wikipedia.org/wiki/SFINAE

template <char... t> using void_char = void;

template <class c, class x = void> struct Recurse {
  static const char Result = Recurse<typename c::Next>::Result;
};

template <class c> struct Recurse<c, void_char<c::Result>> {
  static const char Result = c::Result;
};

int main() {
  // Part 1
  std::cout << Combine<'G', 'R'> << std::endl;  // B

  // Part 2
  //RemoveFirst<'?','R','G','B'>::Result x = 1;  // Row<'R', 'G', 'B'>
  //Row<'B','R','G'>::Next x = 1;                // Row<'G', 'B', '?'>

  // Part 3
  std::cout << Row<'G', '?', '?'>::Result << std::endl;               // G
  std::cout << Row<'B','R','G'>::Next::Next::Result << std::endl;     // R

  std::cout << Recurse<Row<'B','R','G'>>::Result << std::endl;        // R
  std::cout << Recurse<Row<'R','R','G','B','R','G','B','B'>>::Result  // G
    << std::endl;
}
